#ifndef CUBEMAP_H
#define CUBEMAP_H


#include "object.h"

class CubeMap : public Object
{
public :
  // Set default parameters. Radius is 1.0, position is 0,0,0. 
  CubeMap();
  virtual ~CubeMap() {};
  
  // Accesseurs 
  virtual void draw() const;
  virtual float boundingRadius() const { return bradius_; }
  virtual bool intersect(const Ray&, Hit& hit) const;

  virtual void initFromDOMElement(const QDomElement& e);

  QImage &getImage(int i){
	  return cubeImages_[i];
  }

private:
	enum CubeFaces{CM_POS_X=0, CM_NEG_X, CM_POS_Y, CM_NEG_Y, CM_POS_Z, CM_NEG_Z};

  float bradius_;
  mutable QImage cubeImages_[6];

  Color getMapColor(float u, float v, int side) const;
  void loadMap(const QString& fileName, int n);

  mutable GLuint imgTexID[6];
};



#endif //CUBEMAP_H