#ifndef TRIANGLEMESH_H
#define TRIANGLEMESH_H

#include "RTConfig.h"
#include "object.h"
#include <string>
#include <vector>
#include "spacePartition.h"

#include "l3ds.h"

class TriangleMesh : public Object
{
public :
  // Set default parameters. Radius is 1.0, position is 0,0,0. 
  TriangleMesh();
  virtual ~TriangleMesh();
  
  // Accesseurs 
  virtual void draw() const;
  virtual float boundingRadius() const { return bradius_; }
  virtual bool intersect(const Ray&, Hit& hit) const;

  virtual void initFromDOMElement(const QDomElement& e);
  
private:
  float bradius_;
  qglviewer::Vec bbox[2];

  mutable L3DS scene3DS;

  mutable GLuint texID;

  SpacePartition::BoxNode *triTree;

  //qglviewer::Vec gridSize;
};



#endif //TRIANGLEMESH_H